Attribute VB_Name = "modMosquitos"
Option Explicit


Sub Main()
   Dim u&
   ' // Refrence all the Pictureboxes and the form so that they
   ' // can be accessed with less work
   
   ' // mos that face left
   Set MsqPic(0) = frmMain.ms_pic(0)
   Set MsqPic(1) = frmMain.ms_pic(1)
   Set MsqPic(2) = frmMain.ms_pic(2)
   Set MsqPic(3) = frmMain.ms_pic(3)
   Set MsqPic(4) = frmMain.ms_pic(4)
   Set MsqPic(5) = frmMain.ms_pic(5)
   
   Set MsqMsk2(0) = frmMain.ms_msk(0)
   Set MsqMsk2(1) = frmMain.ms_msk(1)
   Set MsqMsk2(2) = frmMain.ms_msk(2)
   Set MsqMsk2(3) = frmMain.ms_msk(3)
   Set MsqMsk2(4) = frmMain.ms_msk(4)
   Set MsqMsk2(5) = frmMain.ms_msk(5)
   
   ' // mos that face right
   Set MsqPic2(0) = frmMain.ms_pic2(0)
   Set MsqPic2(1) = frmMain.ms_pic2(1)
   Set MsqPic2(2) = frmMain.ms_pic2(2)
   Set MsqPic2(3) = frmMain.ms_pic2(3)
   Set MsqPic2(4) = frmMain.ms_pic2(4)
   Set MsqPic2(5) = frmMain.ms_pic2(5)
   
   Set MsqMsk(0) = frmMain.ms_msk2(0)
   Set MsqMsk(1) = frmMain.ms_msk2(1)
   Set MsqMsk(2) = frmMain.ms_msk2(2)
   Set MsqMsk(3) = frmMain.ms_msk2(3)
   Set MsqMsk(4) = frmMain.ms_msk2(4)
   Set MsqMsk(5) = frmMain.ms_msk2(5)
   
    
    ' // start the timers
    Load frmMain
End Sub



Sub InitMos()
   Dim i%, a%
   
   Randomize Timer
   
   For i = 1 To MAX_MOS
      With Cur_Mos(i)
         ' //pick a state for each mosquito; initially
         .State = Int((ZIGZAG_LEFT * Rnd) + MOS_RIGHT)
         ' // pick a random speed between 1 and 5
         .Speed = Int((5 * Rnd) + 1)
         ' // fill out this bugs personality table
         
         For a = 1 To MAX_MOS
            .PerPtrn(a) = Int((MAX_MOS * Rnd) + 1)
            Frm.lblPerTable(a) = .PerPtrn(a) & ","
            .Time(a) = Int((5 * Rnd) + 1)
            ' // Init the ArrayPos
            .ArrayPos = 1
            Debug.Print .PerPtrn(a)
         Next
         
         ' // what side of the screen will this mos start?
         If .State < MOS_LEFT And .State >= MOS_RIGHT Then
            ' //starting left to right
            .x = -100
            .y = Int(((Frm.ScaleHeight - 40) * Rnd) + 1)
         ElseIf .State > ZIGZAG_RIGHT And .State <= ZIGZAG_LEFT Then
            ' // starting right to left
            .x = frmMain.ScaleWidth + 50
            .y = Int(((Frm.ScaleHeight - 40) * Rnd) + 1)
         End If
         
      End With
      Rnd
   Next i
End Sub


Sub ActivateMos()
   ' //
   Dim i As Integer
   ' // Decypher each bugs state.
   For i = 1 To MAX_MOS
   
     Select Case Cur_Mos(i).State
        
        Case MOS_RIGHT
           ' //
           iDirection = MOS_RIGHT
           Cur_Mos(i).x = Cur_Mos(i).x + Cur_Mos(i).Speed
        Case ZIGZAG_RIGHT
           ' //
           iDirection = MOS_RIGHT
           ' // if 2 less than the max is dead
           ' // then make the bug go straight.
           If iNumDead > (MAX_MOS - 2) Then
              Cur_Mos(i).y = Cur_Mos(i).y - 3
              Cur_Mos(i).x = Cur_Mos(i).x + Cur_Mos(i).Speed
           Else
              Cur_Mos(i).x = Cur_Mos(i).x + Cur_Mos(i).Speed
           End If
        Case MOS_LEFT
           ' //
           iDirection = MOS_LEFT
           Cur_Mos(i).x = Cur_Mos(i).x - Cur_Mos(i).Speed
        Case ZIGZAG_LEFT
           ' //
           iDirection = MOS_LEFT
           ' // if 2 less than the max is dead
           ' // then make the bug go straight.
           If iNumDead > (MAX_MOS - 2) Then
              Cur_Mos(i).y = Cur_Mos(i).y + 3
              Cur_Mos(i).x = Cur_Mos(i).x - Cur_Mos(i).Speed
           Else
              Cur_Mos(i).x = Cur_Mos(i).x - Cur_Mos(i).Speed
           End If
           
        Case HOVERING
           ' //
           iDirection = iDirection
           Cur_Mos(i).x = Cur_Mos(i).x
           
        Case ATTACKING
           ' // which way do we face this mosquito
           If mse_x% > Cur_Mos(i).x + 10 Then iDirection = MOS_RIGHT
           If mse_x% < Cur_Mos(i).x - 10 Then iDirection = MOS_LEFT
           
           ' // do x tracking
           If Cur_Mos(i).x < mse_x% Then
              Cur_Mos(i).x = Cur_Mos(i).x + 2
           ElseIf Cur_Mos(i).x > mse_x% Then
              Cur_Mos(i).x = Cur_Mos(i).x - 2
           End If
           
           ' // do y tracking
           If Cur_Mos(i).y < mse_y% Then
              Cur_Mos(i).y = Cur_Mos(i).y + 2
           ElseIf Cur_Mos(i).y > mse_y% Then
              Cur_Mos(i).y = Cur_Mos(i).y - 2
           End If
           
        Case EVADING
           ' // which way do we face this mosquito
           If mse_x% > Cur_Mos(i).x + 10 Then iDirection = MOS_RIGHT
           If mse_x% < Cur_Mos(i).x - 10 Then iDirection = MOS_LEFT
           
           ' // evade x
           If mse_x% > Cur_Mos(i).x Then
              Cur_Mos(i).x = Cur_Mos(i).x + 2
           ElseIf mse_x% < Cur_Mos(i).x Then
              Cur_Mos(i).x = Cur_Mos(i).x - 2
           End If
              
           ' // evade y
           If mse_y% > Cur_Mos(i).y Then
              Cur_Mos(i).y = Cur_Mos(i).y + 2
           ElseIf mse_y% < Cur_Mos(i).y Then
              Cur_Mos(i).y = Cur_Mos(i).y - 2
           End If
           
        Case DROPPING
           iDirection = iDirection
           ' // stop at current position
           Cur_Mos(i).x = Cur_Mos(i).x
           ' // drop straight down
           Cur_Mos(i).y = Cur_Mos(i).y + Cur_Mos(i).Speed
     End Select
     
   ' // Draw and animate this bug
   BlitMos i
   ' // was this mosquito hit??
   If bShotOver And bFired Then DoCollideDetect Cur_Mos(i).x, Cur_Mos(i).y, i
   
   Next i
     
End Sub


Sub BlitMos(CurMos As Integer)
    
    Dim u As Long
    
    Dim i As Integer
    ' // an array of 8 different frame variables
    ' // each one for each different mosquito
    Static frame(1 To MAX_MOS) As Integer
    
    ' // keep the skeeters flying...
    If frame(CurMos) >= 6 Then frame(CurMos) = 0
    
    ' // if the mosquito is dropping... use only frame 3
    If Cur_Mos(CurMos).State = DROPPING Then frame(CurMos) = 3
    
    
    ' // has it gone off the screen??
    If iDirection = MOS_RIGHT Then
      If Cur_Mos(CurMos).x > Frm.ScaleWidth Then
         Cur_Mos(CurMos).x = -45
         ' // pick a random spot for re-entry to the screen.
         Cur_Mos(CurMos).y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
      End If
    ElseIf iDirection = MOS_LEFT Then
      If Cur_Mos(CurMos).x < -50 Then
         Cur_Mos(CurMos).x = Frm.ScaleWidth + 45
         ' // pick a random spot for re-entry to the screen.
         Cur_Mos(CurMos).y = Int(((frmMain.ScaleHeight - 40) * Rnd) + 1)
      End If
    End If
    
    ' // has the dropping mosquito gone off the screen?
    If Cur_Mos(CurMos).y > frmMain.ScaleHeight Then
         Cur_Mos(CurMos).x = Int(((frmMain.ScaleWidth - 40) * Rnd) + 1)
         ' // pick a random spot for re-entry to the screen.
         Cur_Mos(CurMos).y = -35
    End If
    
    
' //// BitBlt calls
    ' // clear the buffer, but only the parts where the
    ' //mosquito was previously.
    u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).x - Cur_Mos(CurMos).Speed, Cur_Mos(CurMos).y - Cur_Mos(CurMos).Speed, _
    80, 80, Frm.picBG.hDC, Cur_Mos(CurMos).x - Cur_Mos(CurMos).Speed, Cur_Mos(CurMos).y - Cur_Mos(CurMos).Speed, SRCCOPY)
        
    ' // do animaton while moving the skeeter.
    If iDirection = MOS_RIGHT Then     ' // right to left
      ' // mask
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).x, Cur_Mos(CurMos).y, _
      MsqMsk2(frame(CurMos)).ScaleWidth, MsqMsk2(frame(CurMos)).ScaleHeight, _
      MsqMsk2(frame(CurMos)).hDC, 0, 0, SRCAND)
      ' // Image
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).x, Cur_Mos(CurMos).y, _
      MsqPic2(frame(CurMos)).ScaleWidth, MsqPic2(frame(CurMos)).ScaleHeight, _
      MsqPic2(frame(CurMos)).hDC, 0, 0, SRCINVERT)
    ElseIf iDirection = MOS_LEFT Then  ' // left to right
      ' // mask
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).x, Cur_Mos(CurMos).y, _
      MsqMsk(frame(CurMos)).ScaleWidth, MsqMsk(frame(CurMos)).ScaleHeight, _
      MsqMsk(frame(CurMos)).hDC, 0, 0, SRCAND)
      ' // Image
      u = BitBlt(Frm.picBuf.hDC, Cur_Mos(CurMos).x, Cur_Mos(CurMos).y, _
      MsqPic(frame(CurMos)).ScaleWidth, MsqPic(frame(CurMos)).ScaleHeight, _
      MsqPic(frame(CurMos)).hDC, 0, 0, SRCINVERT)
    End If
    
    ' // copy the buffered bitmap onto the screen only copy the portion
    ' // around the bug... this is much more efficient and a lot faster
    ' // than copying the entire screen
    u = BitBlt(Frm.hDC, (Cur_Mos(CurMos).x - Cur_Mos(CurMos).Speed), (Cur_Mos(CurMos).y - Cur_Mos(CurMos).Speed), _
    80, 80, Frm.picBuf.hDC, Cur_Mos(CurMos).x - Cur_Mos(CurMos).Speed, Cur_Mos(CurMos).y - Cur_Mos(CurMos).Speed, SRCCOPY)
    
' //// End BItBlt Calls

    ' // advance frame...
    ' // If you desire for the wings to flap faster, simply substitute
    ' // a 2 instead of a 1
    frame(CurMos) = frame(CurMos) + 1
End Sub

' // very simple collision detection... could be a lot more
' // effecient!
Sub DoCollideDetect(x As Long, y As Long, ThisBug As Integer)
    Static hit As Integer
    
    If bFired Then
      If (Shot_x + 10) >= (x + 10) And (Shot_x + 10) <= ((x + 50) - 10) Then
         If (Shot_y + 10) >= (y + 10) And (Shot_y + 10) <= ((y + 40) - 10) Then
            ' //hit
            hit = hit + 1
            bHit = True
            Cur_Mos(ThisBug).State = DEAD
            iNumDead = iNumDead + 1
            iNum_Targets = MAX_MOS - iNumDead
            PlaceDeadBugs ThisBug, iNumDead
            bFired = False
            Exit Sub
         End If
      End If
    End If
End Sub


Sub PlaceDeadBugs(CurMos As Integer, NumKill As Integer)
    ' //
    Dim x%, y%
    Dim u&, offset%
    Dim Kill_x&, Kill_y&
    Const pW% = 36
    
    ' // determine the offset
    If bDoingBugInfo Then offset% = 160 Else offset% = 8
    Kill_x& = 4
    Kill_y& = (Frm.ScaleHeight - (Frm.picKill.ScaleHeight + offset%))
    ' // place an icon representing a shot down bug in the lower left
    ' // corner.
    
    Kill_x& = (Kill_x& + pW%) * NumKill
        
    ' // blit them to the BG
    u& = BitBlt(Frm.picBG.hDC, Kill_x&, Kill_y&, 36, 30, Frm.picKill.hDC, 0, 0, SRCCOPY)
    ' // then to the screen
    u& = BitBlt(Frm.hDC, Kill_x&, Kill_y&, 36, 30, Frm.picKill.hDC, 0, 0, SRCCOPY)
    ' // get the kill off the screen so it can't be shot again.
    Cur_Mos(CurMos).y = Frm.ScaleHeight * 2
End Sub

    ' // This is quite possibly the simplest form of AI...
    ' // depending on whether or not a defined reason is selected
    
    ' // Could be further improved. Given a set of rules to follow, along
    ' // with these states, a better form of fuzzy logic could be implemented.
Sub ChangeStates()
    Dim i As Integer
    Dim a%
    Dim StopTime As Integer
    Dim ChangeSpeed As Integer
    
    Randomize Timer
    
    For i = 1 To MAX_MOS
      ' // the Sprite personailties are rendered according to it's
      ' // personality table and the time in seconds it is supposed
      ' // to remain in that state.
      
      ' // increment this bugs counter
      Cur_Mos(i).TimeCntr = Cur_Mos(i).TimeCntr + 1
      ' // set a variable to = the time for this state to end
      StopTime = Cur_Mos(i).Time(Cur_Mos(i).ArrayPos)
      ' first check to see if it is time to change the current state.
      If Cur_Mos(i).TimeCntr >= StopTime Then
        ' // if encountered a dead bug just go to the next one
        ' // if you exit the procedure here, the bugs will
        ' // stop responding
           If Cur_Mos(i).State = DEAD Then GoTo DoNext
             ' // the time has expired... move to the next state
             ' // in the table
             Cur_Mos(i).State = Cur_Mos(i).PerPtrn(Cur_Mos(i).ArrayPos)
             ' // up the ArrayPos because the time on the last speed is up
             ' // to get ready for the next state
             Cur_Mos(i).ArrayPos = Cur_Mos(i).ArrayPos + 1
             ' // reset the counter
             Cur_Mos(i).TimeCntr = 0
             ' // time to reset the ArrayPos variable??
             If Cur_Mos(i).ArrayPos = 9 Then
                Cur_Mos(i).ArrayPos = 1
             End If
      End If
      
      ' // randomly decide if changing speed
      ChangeSpeed = Int((iNum_Targets * Rnd) + 1)
      If ChangeSpeed = 2 Or ChangeSpeed = iNum_Targets Then
         ' // Change the speed
         Cur_Mos(i).Speed = Int((5 * Rnd) + 1)
      End If

      ' // Display info on the bugs, if wanted
      If bDoingBugInfo Then DoBugInfo (i - 1), StopTime
DoNext:
    Next i
           
End Sub


' // if you choose to execute this function... it will cause the
' // bugs to jerk about..
Sub DoBugInfo(i As Integer, StopTime As Integer)
   Dim b%
   Static p%
   
   If i = 0 Then i = 1
   With Frm
     .lblNum = iNum_Targets
     .lblCurMos = Cur_Mos(i).ArrayPos
     .lblCurState = EvalState(Cur_Mos(Cur_Mos(i).ArrayPos).State)
     p = p + 1
     If p >= MAX_MOS Then
        p = 1
     End If
     If Cur_Mos(p).TimeCntr >= StopTime Then
        For b = 1 To MAX_MOS
           Frm.lblPerTable(b) = EvalState(Cur_Mos(p).PerPtrn(b))
        Next b
     End If
     .lblTimeInState = Cur_Mos(i).Time(Cur_Mos(Cur_Mos(i).ArrayPos).ArrayPos)
     .lblArrayPos = Cur_Mos(Cur_Mos(i).ArrayPos).ArrayPos
     .lblCntr = Cur_Mos(Cur_Mos(i).ArrayPos).TimeCntr
   End With
End Sub


Function EvalState(State As Integer) As String
   Select Case State
      Case 1: EvalState = "MOS_RIGHT"
      Case 2: EvalState = "ZIZZAG_RT"
      Case 3: EvalState = "MOV_LEFT"
      Case 4: EvalState = "ZIGZAG_LT"
      Case 5: EvalState = "HOVERING"
      Case 6: EvalState = "ATTACKING"
      Case 7: EvalState = "EVADING"
      Case 8: EvalState = "DROPPING"
      Case 666: EvalState = "DEAD"
   End Select
End Function

