VERSION 5.00
Object = "{86CF1D34-0C5F-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCT2.OCX"
Begin VB.Form frmMain 
   Caption         =   "Main"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6360
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   377
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   424
   StartUpPosition =   3  'Windows Default
   Begin MSComCtl2.FlatScrollBar ScrollPitch 
      Height          =   2055
      Left            =   5880
      TabIndex        =   7
      Top             =   2520
      Width           =   375
      _ExtentX        =   661
      _ExtentY        =   3625
      _Version        =   393216
      Max             =   360
      Orientation     =   1179648
   End
   Begin MSComCtl2.FlatScrollBar ScrollYaw 
      Height          =   375
      Left            =   3480
      TabIndex        =   6
      ToolTipText     =   "Yaw"
      Top             =   5160
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   2
      Arrows          =   65536
      Max             =   360
      Orientation     =   1179649
   End
   Begin VB.CommandButton cmdDown 
      Caption         =   "D"
      Height          =   375
      Left            =   2520
      TabIndex        =   5
      Top             =   5160
      Width           =   375
   End
   Begin VB.CommandButton cmdUp 
      Caption         =   "U"
      Height          =   375
      Left            =   2520
      TabIndex        =   4
      Top             =   4680
      Width           =   375
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "B"
      Height          =   375
      Left            =   720
      TabIndex        =   3
      Top             =   5160
      Width           =   375
   End
   Begin VB.CommandButton cmdLeft 
      Caption         =   "L"
      Height          =   375
      Left            =   360
      TabIndex        =   2
      Top             =   4800
      Width           =   375
   End
   Begin VB.CommandButton cmdRight 
      Caption         =   "R"
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   4800
      Width           =   375
   End
   Begin VB.CommandButton cmdForward 
      Caption         =   "F"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   4440
      Width           =   375
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim xAngle As GLfloat
Dim yAngle As GLfloat
Dim zAngle As GLfloat

Private Sub cmdBack_Click()
    CameraBack
End Sub

Private Sub cmdDown_Click()
    Tilt_Camera_Down
End Sub

Private Sub cmdForward_Click()
    CameraForward
End Sub

Private Sub cmdLeft_Click()
    CameraLeft
End Sub

Private Sub cmdRight_Click()
    CameraRight
End Sub

Private Sub cmdUp_Click()
    Tilt_Camera_Up
End Sub
Private Sub Form_Load()
    Dim hGLRC As Long
    Dim fAspect As GLfloat
    Call InitializeArrays
    
    xAngle = 0
    yAngle = 0
    zAngle = 0

    SetupPixelFormat hDC
    
    hGLRC = wglCreateContext(hDC)
    wglMakeCurrent hDC, hGLRC
    glEnable GL_DEPTH_TEST
    glEnable GL_DITHER
    glDepthFunc GL_LESS
    glClearDepth 1
    glClearColor 0, 0, 0, 0
    glMatrixMode GL_PROJECTION
    glLoadIdentity
    'glFrustum -1, 1, -1, 1, 1, 10
    If frmMain.ScaleHeight > 0 Then
    fAspect = frmMain.ScaleWidth / frmMain.ScaleHeight
    Else
    fAspect = 0
    End If
    
    gluPerspective 60, fAspect, 1, 2000
    glViewport 0, 0, frmMain.ScaleWidth, frmMain.ScaleHeight
    

    glMatrixMode GL_MODELVIEW
    glLoadIdentity

    glLightfv GL_LIGHT0, GL_POSITION, LightPos(0)

    glEnable GL_LIGHTING
    glEnable GL_LIGHT0
    glShadeModel GL_SMOOTH
    glFrontFace GL_CCW
    
    'glEnable GL_COLOR_MATERIAL
    'glColorMaterial GL_FRONT, GL_AMBIENT_AND_DIFFUSE
    glMaterialfv GL_FRONT, GL_SPECULAR, SpecRef(0)
    glMateriali GL_FRONT, GL_SHININESS, 50

    BuildCube
    BuildGrid
    
    Form_Paint

End Sub
Private Sub Form_Paint()
    Dim i As Integer
    Dim a As Integer
    Dim b As Integer
    Dim c As Integer
    
    glLoadIdentity
    gluLookAt m_Translate_X, m_Translate_Y, m_Translate_Z, m_Translate_X + (100# * (Cos(m_camera_radsFromEast))), m_Translate_Y + m_camera_direction_y, m_Translate_Z - (100# * Sin(m_camera_radsFromEast)), 0#, 1#, 0#
    
    
    glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
    glPushMatrix
        glTranslatef 0, 0, -3
        glRotatef xAngle, 0.1, 0, 0
        glRotatef yAngle, 0, 0.1, 0
        glRotatef zAngle, 0, 0, 1

        glCallList m_Cube
    glPopMatrix
    
    glPushMatrix
    glTranslatef 0, -2, 0
    DisplayGrid
    glPopMatrix
    
    SwapBuffers hDC
        
End Sub
Private Sub Form_Resize()

    glViewport 0, 0, frmMain.ScaleWidth, frmMain.ScaleHeight
    Form_Paint
End Sub
Private Sub Form_Unload(Cancel As Integer)
    If hGLRC <> 0 Then
        wglMakeCurrent 0, 0
        wglDeleteContext hGLRC
    End If
    
    If hPalette <> 0 Then
        DeleteObject hPalette
    End If

End Sub
Sub BuildCube()
    Dim i As Integer
    Dim a As Integer
    Dim b As Integer
    Dim c As Integer
    
    m_Cube = glGenLists(1)
    glNewList m_Cube, GL_COMPILE_AND_EXECUTE
            
    For i = 0 To TRIANGLE_COUNT - 1
        a = index(i, 0)
        b = index(i, 1)
        c = index(i, 2)
        Call RenderTriangle(a, b, c)
    Next
        
    glEnd
    glEndList

End Sub

Sub BuildGrid()
    Dim r As Integer
    Dim c As Integer
    Dim nStep As Integer
    
    nStep = 5
    glPushMatrix
    m_Grid = glGenLists(1)
    glNewList m_Grid, GL_COMPILE
    glBegin (GL_LINES)
        For r = -50 To 50 Step nStep
            glVertex3f r, 0#, -50#
            glVertex3f r, 0#, 50#
        Next
        For c = -50 To 50 Step nStep
            glVertex3f 50#, 0#, c
            glVertex3f -50#, 0#, c
        Next
    glEnd
    glEndList
    glPopMatrix

End Sub
Sub DisplayGrid()

    glPushAttrib GL_LIGHTING
    glDisable GL_LIGHTING
    
    glPushMatrix
        glColor3ub 0, 255, 0
        'Bottom
        glCallList m_Grid
        '/*Back*/
        glPushMatrix
            glTranslatef 0#, 50#, -50#
            glPushMatrix
                glRotatef 90#, 1#, 0#, 0#
                glCallList m_Grid
            glPopMatrix
        glPopMatrix
        '/*Front*/
        glPushMatrix
            glTranslatef 0#, 50#, 50#
            glPushMatrix
                glRotatef 90#, 1#, 0#, 0#
                glCallList m_Grid
            glPopMatrix
        glPopMatrix
        '/*Left Side*/
        glPushMatrix
            glTranslatef -50#, 50#, 0#
            glPushMatrix
                glRotatef 90, 0#, 0#, 1#
                glCallList m_Grid
            glPopMatrix
        glPopMatrix
        '/*Right Side*/
        glPushMatrix
            glTranslatef 50#, 50#, 0#
            glPushMatrix
                glRotatef 90, 0#, 0#, 1#
                glCallList m_Grid
            glPopMatrix
        glPopMatrix
    glPopMatrix
    glPopAttrib
    glEnable GL_LIGHTING

End Sub


Sub MoveCamera(dStep As Double)

    Dim xChange As Double
    Dim zChange As Double
    
    xChange = dStep * Cos(m_camera_radsFromEast)
    zChange = -dStep * Sin(m_camera_radsFromEast)
    
    If ((m_Translate_X < 40 + xChange) And (m_Translate_X + xChange) > -40) Then
        m_Translate_X = m_Translate_X + xChange
    Else
        m_Translate_X = m_Translate_X - xChange
    End If
    
    If ((m_Translate_Z + zChange) < 40 And (m_Translate_Z + zChange) > -40) Then
        m_Translate_Z = m_Translate_Z + zChange
    Else
        m_Translate_Z = m_Translate_Z - zChange
    End If
    
End Sub

Private Sub CameraLeft()
    m_camera_radsFromEast = m_camera_radsFromEast + (10# / 180# * 3.142)
    If (m_camera_radsFromEast > (6.28)) Then
        m_camera_radsFromEast = 0#
    End If
    Form_Paint
End Sub
    
Private Sub CameraRight()

    m_camera_radsFromEast = m_camera_radsFromEast - (10# / 180# * 3.142)
    If (m_camera_radsFromEast < 0#) Then
       m_camera_radsFromEast = 6.28
    End If
    Form_Paint
End Sub

Private Sub CameraForward()
    Call MoveCamera(m_translationUnit)
    Form_Paint
End Sub
Private Sub CameraBack()
    Call MoveCamera(-1# * m_translationUnit)
    Form_Paint
End Sub

Private Sub Tilt_Camera_Up()
    m_camera_direction_y = m_camera_direction_y + 10
    Form_Paint
End Sub
Sub Tilt_Camera_Down()
    m_camera_direction_y = m_camera_direction_y - 10
    Form_Paint
End Sub

Private Sub ScrollPitch_Change()
    xAngle = ScrollPitch.Value
    Form_Paint

End Sub

Private Sub ScrollPitch_Scroll()
    xAngle = ScrollPitch.Value
    Form_Paint

End Sub

Private Sub ScrollYaw_Change()
    yAngle = ScrollYaw.Value
    Form_Paint

End Sub

Private Sub ScrollYaw_Scroll()
    yAngle = ScrollYaw.Value
    Form_Paint

End Sub
